"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const schematics_1 = require("@angular-devkit/schematics");
const tasks_1 = require("@angular-devkit/schematics/tasks");
const config_1 = require("../utility/config");
function default_1() {
    return (host, context) => {
        /* Get config */
        const angularMajorVersion = (0, config_1.getDependencyMajorVersion)('@angular/core', host);
        if (!angularMajorVersion) {
            context.logger.warn(`Not able to detect @angular/core version. Be aware that Angular versions <= 10 are no longer supported.`);
        }
        if (angularMajorVersion && (angularMajorVersion <= 10)) {
            throw new schematics_1.SchematicsException('Angular versions <= 10 are no longer supported.');
        }
        const rxjsMajorVersion = (0, config_1.getDependencyMajorVersion)('rxjs', host);
        if (!rxjsMajorVersion) {
            context.logger.warn(`Not able to detect rxjs version. Be aware that rxjs version >= 7.4 is recommended for Angular >= 13.`);
        }
        if (angularMajorVersion && rxjsMajorVersion
            && (angularMajorVersion >= 13) && (rxjsMajorVersion < 7)) {
            context.logger.warn(`rxjs should be updated to version >= 7.4. Support for rxjs version 6 is not guaranteed.`);
        }
        /* Task to run `npm install` (or user package manager) */
        context.addTask(new tasks_1.NodePackageInstallTask());
        return (0, schematics_1.chain)([]);
    };
}
exports.default = default_1;
//# sourceMappingURL=index.js.map