"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAllMainPaths = exports.getDependencyMajorVersion = exports.packageName = void 0;
const schematics_1 = require("@angular-devkit/schematics");
const dependencies_1 = require("@schematics/angular/utility/dependencies");
const workspace_1 = require("@schematics/angular/utility/workspace");
exports.packageName = '@ngx-builders/pwa-local-storage';
function getDependencyMajorVersion(name, host) {
    const dependency = (0, dependencies_1.getPackageJsonDependency)(host, name);
    /* Throw if Angular is not installed */
    if (dependency === null) {
        return undefined;
    }
    /* Remove semver signs if present and keep only the first number (major) */
    // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
    return Number.parseInt(dependency.version.replace('~', '').replace('^', '').split('.')[0], 10);
}
exports.getDependencyMajorVersion = getDependencyMajorVersion;
function getAllMainPaths(host) {
    return __awaiter(this, void 0, void 0, function* () {
        const mainPaths = [];
        const workspace = yield (0, workspace_1.getWorkspace)(host);
        /* Loop on all projects configured in angular.json */
        workspace.projects.forEach((project) => {
            /* The schematic only work with applications (not librairies) */
            if (project.extensions['projectType'] === 'application') {
                /* Get `main` option in angular.json project config */
                const buildTarget = project.targets.get('build');
                const e2eTarget = project.targets.get('e2e');
                if (buildTarget) {
                    if (!buildTarget.options || !buildTarget.options['main']) {
                        throw new schematics_1.SchematicsException(`angular.json config is broken, can't find 'architect.build.options.main' in one or more projects`);
                    }
                    mainPaths.push(buildTarget.options['main']);
                }
                else if (!e2eTarget) {
                    /* In old CLI projects, e2e where distinct applications project, we don't need to throw for them */
                    throw new schematics_1.SchematicsException(`angular.json config is broken, can't find 'architect.build.options.main' in one or more projects`);
                }
            }
        });
        return mainPaths;
    });
}
exports.getAllMainPaths = getAllMainPaths;
//# sourceMappingURL=config.js.map